<template>
  <div id="page" :class="classes">
    <header v-if="!noHeader" id="page-header">
      <slot name="header">
        <h1 class="page-title" v-html="$meta.title"></h1>
        <p class="page-description" v-if="$meta.description" v-html="$meta.description"></p>
      </slot>
    </header>

    <div id="page-content">
      <slot/>
    </div>
  </div>
</template>

<script>
export default {
  name: 'page',

  props: {
    name: {
      type: String,
      default: ''
    },

    title: {
      type: String,
      default: ''
    },

    noHeader: {
      type: Boolean,
      default: false
    },

    icon: {
      type: String,
      default: ''
    },

    description: {
      type: String
    },

    fluid: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    $meta () {
      const routeMeta = Object.assign({}, this.$route.meta)
      const name = this.name || this.$route.name

      return {
        name: `page-${name}`,
        title: this.title || routeMeta.title,
        icon: this.icon || routeMeta.icon,
        description: this.description || routeMeta.description
      }
    },

    classes () {
      const classes = [
        'page-container',
        this.$meta.name.replace(/\./g, '-')
      ]

      if (this.fluid) {
        classes.push('fluid')
      }

      return classes
    }
  }
}
</script>

<style lang="scss">
@import '~bootstrap/scss/grid';

#page {
  min-height: calc(100vh - (#{$headbar-height} + #{$footer-height} + #{$footer-border-width}));

  &.page-container {
    transition: ease-in-out .34s;
    @include make-container();

    @include media-breakpoint-up(sm) {
      padding-right: $grid-gutter-width;
      padding-left: $grid-gutter-width;
    }

    &:not(.fluid) {
      @include media-breakpoint-up(md) {
        max-width: map-get($container-max-widths, "xl");
      }
    }
  }

  &-header {
    min-height: $header-height;
    border-bottom: 1px solid $border-color;

    .page-title {
      font-size: 24px;
      line-height: $header-height;
      font-weight: $font-weight-base;
      margin-bottom: 0;
    }
  }

  &-content {
    padding: $page-gutter;
    margin-right: -$page-gutter;
    margin-left: -$page-gutter;

    @include media-breakpoint-up(sm) {
      margin-right: -$grid-gutter-width;
      margin-left: -$grid-gutter-width;
      padding-right: $grid-gutter-width;
      padding-left: $grid-gutter-width;
    }

    > section {
      margin-bottom: $page-gutter;

      @include media-breakpoint-up(sm) {
        margin-bottom: $grid-gutter-width;
      }
    }
  }
}
</style>
